package symantec.itools.awt;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Polygon;
import symantec.itools.lang.OS;

public class DirectionButton extends ButtonBase {
   public static final int LEFT = 0;
   public static final int RIGHT = 1;
   // $FF: renamed from: UP int
   public static final int field_0 = 2;
   public static final int DOWN = 3;
   private int direction;
   private int left;
   private int right;
   private int top;
   private int bottom;
   private int indent;
   private Polygon poly;

   public DirectionButton() {
      this(0);
   }

   public DirectionButton(int var1) {
      this.direction = var1;
      this.left = 0;
      this.right = 0;
      this.bottom = 0;
      this.indent = 0;
      this.poly = null;
   }

   public void setDirection(int var1) {
      this.direction = var1;
   }

   public int getDirection() {
      return this.direction;
   }

   public void setArrowIndent(int var1) {
      this.indent = var1;
      ((Component)this).invalidate();
   }

   public int getArrowIndent() {
      return this.indent;
   }

   public void shrinkTriangle(int var1, int var2, int var3, int var4) {
      this.left = var1;
      this.right = var2;
      this.top = var3;
      this.bottom = var4;
   }

   public void paint(Graphics var1) {
      super.paint(var1);
      this.updatePolygon();
      if (((Component)this).isEnabled()) {
         var1.setColor(Color.black);
      } else {
         var1.setColor(Color.gray);
      }

      var1.fillPolygon(this.poly);
   }

   public Dimension preferredSize() {
      Dimension var1 = ((Component)this).size();
      return new Dimension(Math.max(var1.width, ((Component)this).minimumSize().width), Math.max(var1.height, ((Component)this).minimumSize().height));
   }

   void updatePolygon() {
      Dimension var1 = ((Component)this).size();
      this.poly = new Polygon();
      int var2 = var1.width / 2 + super.pressedAdjustment;
      int var3 = var1.height / 2 + super.pressedAdjustment;
      int var4 = this.top + super.bevel * 2 + super.pressedAdjustment + this.indent;
      int var5 = var1.height - this.bottom - super.bevel * 2 + super.pressedAdjustment - this.indent;
      int var6 = this.left + super.bevel * 2 + super.pressedAdjustment + this.indent;
      int var7 = var1.width - this.right - super.bevel * 2 + super.pressedAdjustment - this.indent;
      switch (this.direction) {
         case 0:
            if (OS.isMacintosh()) {
               this.poly.addPoint(var6 - 2, var3 - 1);
               this.poly.addPoint(var7 - 2, var4 - 1);
               this.poly.addPoint(var7 - 2, var5 - 1);
               return;
            }

            this.poly.addPoint(var6, var3);
            this.poly.addPoint(var7, var4);
            this.poly.addPoint(var7, var5);
            return;
         case 1:
            if (OS.isMacintosh()) {
               this.poly.addPoint(var7 - 1, var3 - 1);
               this.poly.addPoint(var6, var4 - 1);
               this.poly.addPoint(var6, var5 - 2);
               return;
            }

            this.poly.addPoint(var7, var3);
            this.poly.addPoint(var6, var4);
            this.poly.addPoint(var6, var5);
            return;
         case 2:
            if (OS.isMacintosh()) {
               this.poly.addPoint(var2 - 1, var4 - 1);
               this.poly.addPoint(var6 - 1, var5 - 2);
               this.poly.addPoint(var7 - 2, var5 - 2);
               return;
            }

            this.poly.addPoint(var2, var4);
            this.poly.addPoint(var6, var5);
            this.poly.addPoint(var7, var5);
            return;
         case 3:
            if (OS.isMacintosh()) {
               this.poly.addPoint(var2 - 1, var5);
               this.poly.addPoint(var6 - 1, var4);
               this.poly.addPoint(var7 - 1, var4);
               return;
            }

            this.poly.addPoint(var2, var5);
            this.poly.addPoint(var6, var4);
            this.poly.addPoint(var7, var4);
            return;
         default:
      }
   }
}
