package symantec.itools.awt;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Event;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.Rectangle;
import java.awt.Scrollbar;
import java.util.BitSet;
import java.util.Date;
import java.util.Vector;
import symantec.beans.Beans;

public class MultiList extends Panel {
   public static final long CLICKTHRESHOLD = 250L;
   public static final int LEFT = 0;
   public static final int CENTER = 1;
   public static final int RIGHT = 2;
   static CompareCells func = new CompareCells();
   Color colorBg;
   Color colorFg;
   Color colorHBg;
   Color colorHFg;
   Matrix cells;
   boolean multiSelect;
   int[] splitters;
   String[] headings;
   int[] align;
   Image[] cellIm;
   int[] columnSizes;
   Color headingBg;
   Color headingFg;
   Font headingFont;
   Font cellFont;
   // $FF: renamed from: sb java.awt.Scrollbar
   Scrollbar field_0;
   int cursor;
   int colClick;
   int memoryClick;
   long clickTime;
   BitSet highlightedRows;
   int selectedRow;
   int topRow;
   int dragColumn;
   int xDragLast;
   boolean isDragging;
   int headingHeight;
   int cellHeight;
   int cellAscent;
   int cellDescent;
   int clickMargin;
   int currentCursor;
   // $FF: renamed from: im java.awt.Image
   Image field_1;
   // $FF: renamed from: gg java.awt.Graphics
   Graphics field_2;
   int height;
   int width;
   int sbPosition;
   long scrollbarTimer;

   public MultiList() {
      this(0, false, Color.white);
   }

   public MultiList(int var1) {
      this(var1, false, Color.white);
   }

   public MultiList(int var1, boolean var2) {
      this(var1, var2, Color.white);
   }

   public MultiList(int var1, boolean var2, Color var3) {
      this.colorBg = Color.white;
      this.colorFg = Color.black;
      this.colorHBg = Color.blue;
      this.colorHFg = Color.white;
      this.cells = new Matrix();
      this.multiSelect = false;
      this.headingBg = Color.lightGray;
      this.headingFg = Color.black;
      this.colClick = -1;
      this.memoryClick = -1;
      this.highlightedRows = new BitSet();
      this.dragColumn = -1;
      this.xDragLast = -1;
      this.clickMargin = 5;
      this.height = -1;
      this.width = -1;
      this.createColumns(var1);
      this.multiSelect = var2;
      ((Container)this).setLayout(new BorderLayout());
      this.setHeadingFont(new Font("Helvetica", 0, 12));
      this.setCellFont(new Font("Helvetica", 0, 12));
      ((Component)this).setBackground(this.colorBg = var3);
      this.field_0 = new Scrollbar(1);
      this.field_0.hide();
      ((Container)this).add("East", this.field_0);
   }

   public void setColumns(int var1) {
      this.createColumns(var1);
   }

   public int getColumns() {
      return this.headings.length;
   }

   public void setHeading(String var1, int var2, int var3) {
      this.headings[var2] = var1;
      this.splitters[var2 + 1] = var3;
      this.redraw();
      ((Component)this).repaint();
   }

   public String getHeading(int var1) {
      return this.headings[var1];
   }

   public void adjustHeadings() {
      if (this.headings.length == 0) {
         this.createColumns(0);
         ((Component)this).invalidate();
      } else {
         Dimension var1 = ((Component)this).size();
         int var2 = 0;
         int var3 = var1.width / this.headings.length;
         this.splitters[0] = 0;

         for(int var4 = 0; var4 < this.headings.length; ++var4) {
            this.splitters[var4 + 1] = var2 += var3;
         }

      }
   }

   public void setHeadings(String[] var1) {
      if (var1.length == 0) {
         this.createColumns(0);
         ((Component)this).invalidate();
      } else {
         Dimension var2 = ((Component)this).size();
         int var3 = 0;
         int var4 = var2.width / var1.length;
         this.splitters[0] = 0;
         this.createColumns(var1.length);

         for(int var5 = 0; var5 < var1.length; ++var5) {
            this.setHeading(var1[var5], var5, var3 += var4);
         }
      }

      this.redraw();
      ((Component)this).repaint();
   }

   public String[] getHeadings() {
      return this.headings;
   }

   public void setHeadingFont(Font var1) {
      this.headingFont = var1;
      this.headingHeight = ((Component)this).getFontMetrics(var1).getHeight() + 4;
      this.redraw();
      ((Component)this).repaint();
   }

   public Font getHeadingFont() {
      return this.headingFont;
   }

   public void setCellFont(Font var1) {
      this.cellFont = var1;
      this.cellAscent = ((Component)this).getFontMetrics(var1).getAscent();
      this.cellDescent = ((Component)this).getFontMetrics(var1).getDescent();
      this.cellHeight = ((Component)this).getFontMetrics(var1).getHeight();
      this.redraw();
      ((Component)this).repaint();
   }

   public Font getCellFont() {
      return this.cellFont;
   }

   public void setHeadingColors(Color var1, Color var2) {
      this.headingFg = var1;
      this.headingBg = var2;
      this.redraw();
      ((Component)this).repaint();
   }

   public void setHeadingFg(Color var1) {
      this.headingFg = var1;
      this.redraw();
      ((Component)this).repaint();
   }

   public void setHeadingBg(Color var1) {
      this.headingBg = var1;
      this.redraw();
      ((Component)this).repaint();
   }

   public Color getHeadingFg() {
      return this.headingFg;
   }

   public Color getHeadingBg() {
      return this.headingBg;
   }

   public void setCellColors(Color var1, Color var2) {
      this.colorFg = var1;
      this.colorBg = var2;
      this.redraw();
      ((Component)this).repaint();
   }

   public void setCellFg(Color var1) {
      this.colorFg = var1;
      this.redraw();
      ((Component)this).repaint();
   }

   public void setCellBg(Color var1) {
      this.colorBg = var1;
      this.redraw();
      ((Component)this).repaint();
   }

   public Color getCellFg() {
      return this.colorFg;
   }

   public Color getCellBg() {
      return this.colorBg;
   }

   public String[] getColumnAlignments() {
      String[] var1 = new String[this.align.length];

      for(int var2 = 0; var2 < var1.length; ++var2) {
         if (this.align[var2] == 0) {
            var1[var2] = "Left";
         } else if (this.align[var2] == 1) {
            var1[var2] = "Center";
         } else if (this.align[var2] == 2) {
            var1[var2] = "Right";
         } else {
            var1[var2] = "Left";
         }
      }

      return var1;
   }

   public void setColumnAlignments(String[] var1) {
      if (var1.length > 0) {
         this.align = new int[var1.length];

         for(int var3 = 0; var3 < var1.length; ++var3) {
            if (var1[var3] != null) {
               if (var1[var3].equalsIgnoreCase("Left")) {
                  this.align[var3] = 0;
               } else if (var1[var3].equalsIgnoreCase("Center")) {
                  this.align[var3] = 1;
               } else if (var1[var3].equalsIgnoreCase("Right")) {
                  this.align[var3] = 2;
               } else {
                  this.align[var3] = 0;
               }
            } else {
               this.align[var3] = 0;
            }
         }

      } else {
         this.align = new int[this.headings.length];

         for(int var2 = 0; var2 < this.headings.length; ++var2) {
            this.align[var2] = 0;
         }

      }
   }

   public String[] getColumnSizes() {
      String[] var1 = new String[this.columnSizes.length];

      for(int var2 = 0; var2 < var1.length; ++var2) {
         try {
            var1[var2] = String.valueOf(this.columnSizes[var2]);
         } catch (Exception var3) {
            var1[var2] = "";
         }
      }

      return var1;
   }

   public void setColumnSizes(String[] var1) {
      if (var1.length <= 0) {
         this.columnSizes = null;
         this.adjustHeadings();
      } else {
         this.columnSizes = new int[var1.length];
         int var2 = 0;

         for(int var3 = 0; var3 < var1.length; ++var3) {
            try {
               if (var1[var3] != null) {
                  this.columnSizes[var3] = Integer.parseInt(var1[var3]);
                  if (this.splitters.length >= var3) {
                     this.splitters[var3 + 1] = var2 += this.columnSizes[var3];
                  }
               }
            } catch (Exception var4) {
               this.columnSizes[var3] = 10;
               if (this.splitters.length >= var3) {
                  int var10001 = var3 + 1;
                  var2 += 10;
                  this.splitters[var10001] = var2;
               }
            }
         }

         this.splitters[0] = 0;
      }
   }

   public int getColumnSize(int var1) {
      return this.splitters[var1];
   }

   public void setColumnAlignment(int var1, int var2) {
      this.align[var1] = var2;
   }

   public int getNumberofCols() {
      return this.headings.length;
   }

   public void setSelectedRow(int var1) throws IllegalArgumentException {
      if (var1 > this.cells.rows()) {
         throw new IllegalArgumentException(var1 + " is not a valid row number");
      } else {
         this.selectedRow = var1;
         this.redraw();
         ((Component)this).repaint();
      }
   }

   public int getSelectedRow() {
      return this.selectedRow;
   }

   public int[] getSelectedRows() {
      int var1 = this.highlightedRows.size();
      int var2 = 0;

      for(int var3 = 0; var3 < var1; ++var3) {
         if (this.highlightedRows.get(var3)) {
            ++var2;
         }
      }

      int[] var4 = new int[var2];
      var2 = 0;

      for(int var5 = 0; var5 < var1; ++var5) {
         if (this.highlightedRows.get(var5)) {
            var4[var2++] = var5;
         }
      }

      return var4;
   }

   public boolean mouseDown(Event var1, int var2, int var3) {
      if (var3 < this.headingHeight) {
         for(int var4 = 1; var4 < this.headings.length; ++var4) {
            if (var2 < this.splitters[var4] + this.clickMargin && var2 > this.splitters[var4] - this.clickMargin) {
               this.dragColumn = var4;
               this.isDragging = true;
               this.mouseDrag(var1, var2, var3);
               return true;
            }
         }

         for(int var5 = 0; var5 < this.headings.length; ++var5) {
            int var6 = var5 == this.headings.length - 1 ? ((Component)this).size().width : this.splitters[var5 + 1];
            if (var2 > this.splitters[var5] && var2 < var6) {
               this.colClick = var5;
               this.drawHeading(true);
               ((Component)this).repaint();
               return true;
            }
         }
      }

      if (var2 > this.width) {
         return false;
      } else {
         int var7 = this.selectedRow;
         this.changeSelection((var3 - this.headingHeight - 4) / this.cellHeight + this.topRow, var1.modifiers);
         if (this.selectedRow == var7 || var7 < 0) {
            long var8 = var1.when - this.clickTime;
            if (var8 < 250L) {
               this.postEvent(1001, this.selectedRow);
            }
         }

         this.clickTime = var1.when;
         return false;
      }
   }

   public boolean mouseDrag(Event var1, int var2, int var3) {
      Dimension var4 = ((Component)this).size();
      if (this.isDragging) {
         if (var2 < 0) {
            var2 = 0;
         }

         this.field_2.setColor(this.colorBg);
         this.field_2.setXORMode(Color.black);
         this.field_2.drawLine(this.xDragLast, 0, this.xDragLast, var4.height);
         this.field_2.drawLine(var2, 0, var2, var4.height);
         this.field_2.setColor(Color.black);
         this.field_2.setPaintMode();
         this.xDragLast = var2;
         ((Component)this).repaint();
         return true;
      } else {
         if (this.colClick > -1) {
            int var6;
            if (this.colClick == 0) {
               var6 = 0;
            } else {
               var6 = this.splitters[this.colClick];
            }

            int var5;
            if (this.colClick == this.headings.length - 1) {
               var5 = var4.width;
            } else {
               var5 = this.splitters[this.colClick + 1];
            }

            if (var2 < var6 || var2 > var5 || var3 > this.headingHeight || var3 < 0) {
               this.memoryClick = this.colClick;
               this.colClick = -1;
               this.drawHeading(false);
               ((Component)this).repaint();
            }
         } else if (this.memoryClick > -1) {
            int var8;
            if (this.memoryClick == 0) {
               var8 = 0;
            } else {
               var8 = this.splitters[this.memoryClick];
            }

            int var7;
            if (this.memoryClick == this.headings.length - 1) {
               var7 = var4.width;
            } else {
               var7 = this.splitters[this.memoryClick + 1];
            }

            if (var2 > var8 && var2 < var7 && var3 < this.headingHeight && var3 > 0) {
               this.colClick = this.memoryClick;
               this.memoryClick = -1;
               this.drawHeading(false);
               ((Component)this).repaint();
            }
         }

         return true;
      }
   }

   public boolean mouseUp(Event var1, int var2, int var3) {
      if (this.isDragging) {
         if (var2 < 0) {
            var2 = 0;
         }

         this.field_2.setColor(this.colorBg);
         this.field_2.setXORMode(Color.black);
         this.field_2.drawLine(this.xDragLast, 0, this.xDragLast, ((Component)this).size().height);
         this.field_2.setColor(Color.black);
         this.field_2.setPaintMode();
         this.xDragLast = -1;
         this.isDragging = false;
         this.splitters[this.dragColumn] = var2;
         this.redraw();
         ((Component)this).repaint();
         return true;
      } else if (this.colClick != -1) {
         this.highlightedRows = new BitSet();
         this.selectedRow = -1;
         this.cells.sort(func, this.colClick);
         this.colClick = -1;
         this.redraw();
         ((Component)this).repaint();
         return true;
      } else {
         return false;
      }
   }

   public boolean mouseMove(Event var1, int var2, int var3) {
      boolean var4 = false;
      if (var3 < this.headingHeight) {
         for(int var5 = 1; var5 < this.headings.length; ++var5) {
            if (var2 < this.splitters[var5] + this.clickMargin && var2 > this.splitters[var5] - this.clickMargin) {
               var4 = true;
            }
         }
      }

      int var7 = var4 ? 10 : 0;
      if (var7 != this.currentCursor) {
         Frame var6 = this.frame();
         if (var6 != null) {
            var6.setCursor(this.currentCursor = var7);
         }
      }

      return false;
   }

   public boolean keyDown(Event var1, int var2) {
      switch (var2) {
         case 10:
            if (this.selectedRow > -1) {
               this.postEvent(1001, this.selectedRow);
            }
            break;
         case 1002:
            this.changeSelection(this.selectedRow - this.getPageSize(), var1.modifiers);
            break;
         case 1003:
            this.changeSelection(this.selectedRow + this.getPageSize(), var1.modifiers);
            break;
         case 1004:
            if (this.selectedRow > 0) {
               this.changeSelection(this.selectedRow - 1, var1.modifiers);
            }
            break;
         case 1005:
            if (this.selectedRow < this.cells.rows() - 1) {
               this.changeSelection(this.selectedRow + 1, var1.modifiers);
            }
      }

      return false;
   }

   public boolean handleEvent(Event var1) {
      if (var1.target == this.field_0 && var1.arg != null) {
         Date var2 = new Date();
         var1.when = var2.getTime();
         if (var1.when - this.scrollbarTimer < 300L && var1.id == 605) {
            return false;
         }

         this.scrollbarTimer = var1.when;
         if (this.topRow != this.field_0.getValue()) {
            this.topRow = this.field_0.getValue();
            this.sbPosition = this.topRow;
            this.redraw();
            ((Component)this).repaint();
         }
      }

      return super.handleEvent(var1);
   }

   public void createColumns(int var1) {
      this.headings = new String[var1];
      this.align = new int[var1];
      this.splitters = new int[var1 + 1];
      this.cellIm = new Image[var1];
      this.columnSizes = null;
   }

   public void clear() {
      this.cells.removeAllElements();
      this.xDragLast = -1;
      this.isDragging = false;
      this.selectedRow = 0;
      this.highlightedRows = new BitSet();
      this.topRow = 0;
   }

   public void addTextCell(int var1, int var2, String var3) {
      Cell var4 = new Cell(this, var3);
      this.cells.updateElement(var1, var2, var4);
      ((Component)this).repaint();
   }

   public void addImageCell(int var1, int var2, Image var3) {
      Cell var4 = new Cell(this, var3);
      this.cells.updateElement(var1, var2, var4);
      ((Component)this).repaint();
   }

   public void addCell(int var1, int var2, String var3, Image var4) {
      Cell var5 = new Cell(this, var3, var4);
      this.cells.updateElement(var1, var2, var5);
      ((Component)this).repaint();
   }

   public String getCellText(int var1, int var2) {
      Cell var3 = (Cell)this.cells.elementAt(var1, var2);
      return var3 != null ? var3.text : null;
   }

   public void setListItems(String[] var1) {
      this.clear();

      for(int var2 = 0; var2 < var1.length; ++var2) {
         String var3 = var1[var2];
         if (var3 == null) {
            var3 = new String("");
         }

         int var4 = var3.length();
         int var5 = 0;
         int var7 = 0;

         for(int var6 = 0; var6 <= var4 && var7 < this.headings.length; ++var6) {
            if (var6 == var4 || var3.charAt(var6) == ';') {
               this.addCell(var2, var7++, var3.substring(var5, var6), (Image)null);
               var5 = var6 + 1;
            }
         }

         while(var7 < this.headings.length) {
            this.addCell(var2, var7++, "", (Image)null);
         }
      }

      this.redraw();
      ((Component)this).repaint();
   }

   public String[] getListItems() {
      new Vector();
      String[] var5 = new String[this.cells.rows()];

      for(int var2 = 0; var2 < this.cells.rows(); ++var2) {
         String var4 = "";

         for(int var3 = 0; var3 < this.headings.length; ++var3) {
            String var1 = this.getCellText(var2, var3);
            if (var3 != 0) {
               var4 = var4 + ";";
            }

            var4 = var4 + (var1 != null ? var1 : "");
         }

         var5[var2] = var4;
      }

      return var5;
   }

   public void update(Graphics var1) {
      this.paint(var1);
   }

   void checkClipping(Graphics var1) {
      Rectangle var2 = var1.getClipRect();
      Dimension var3 = ((Component)this).size();
      if (var2.x != 0 || var2.y != 0 || var2.width != var3.width || var2.height != var3.height) {
         ((Component)this).repaint();
      }

   }

   public void paint(Graphics var1) {
      this.checkClipping(var1);
      Font var2 = var1.getFont();
      Dimension var3 = ((Component)this).size();
      if (var2 == null) {
         var2 = this.headingFont;
         ((Component)this).setFont(var2);
      } else {
         if (this.width != var3.width || this.height != var3.height || Beans.isDesignTime()) {
            this.redraw();
         }

         var1.drawImage(this.field_1, 0, 0, this);
      }
   }

   public void redraw() {
      Dimension var1 = ((Component)this).size();
      if (var1.width != 0 && var1.height != 0) {
         if (this.width != var1.width || this.height != var1.height) {
            this.field_1 = ((Component)this).createImage(this.width = var1.width, this.height = var1.height);
            if (this.field_2 != null) {
               this.field_2.dispose();
            }

            this.field_2 = this.field_1.getGraphics();
         }

         this.field_2.setColor(this.colorBg);
         this.field_2.fillRect(0, 0, this.width, this.height);
         if (this.cellHeight > 0 && this.cells.rows() * this.cellHeight > this.height - this.headingHeight) {
            this.field_0.setValues(this.sbPosition, this.height / this.cellHeight, 0, this.cells.rows() - 1);
            this.field_0.setPageIncrement(1);
            this.field_0.show();
            ((Component)this).getParent().paintAll(((Component)this).getParent().getGraphics());
         } else {
            this.topRow = 0;
            this.field_0.hide();
         }

         this.field_2.setFont(this.headingFont);
         this.drawHeading(false);
         int var2 = this.topRow + (this.cellHeight > 0 ? (this.height - 3) / this.cellHeight - 1 : 0);
         if (var2 > this.cells.rows()) {
            var2 = this.cells.rows();
         }

         this.field_2.setFont(this.cellFont);
         this.drawRows(0, var2, this.topRow);
      }
   }

   public synchronized void reshape(int var1, int var2, int var3, int var4) {
      super.reshape(var1, var2, var3, var4);
      if (this.columnSizes == null) {
         this.adjustHeadings();
      }

   }

   void drawRows(int var1, int var2, int var3) {
      MatrixEnumeration var4 = this.cells.elements();
      Cell var5 = null;
      int var8 = this.headings.length;
      if (var3 > 0) {
         var5 = (Cell)var4.advanceTo(var3);
      }

      while(var4.hasMoreElements() || var5 != null) {
         for(int var9 = 0; var9 < var8; ++var9) {
            int var7;
            if (var9 < var8 - 1) {
               var7 = this.splitters[var9 + 1] - this.splitters[var9];
            } else {
               int var10001 = this.splitters[var9];
               var7 = ((Component)this).size().width - var10001 - 4;
            }

            int var6 = var9 == 0 ? 1 : this.splitters[var9] - 3;
            this.field_2.setColor(this.highlightedRows.get(var3) ? this.colorHBg : this.colorBg);
            this.field_2.fillRect(var6, this.headingHeight + var1 * this.cellHeight + 4, var7 + 4, this.cellHeight);
            this.field_2.setColor(this.highlightedRows.get(var3) ? this.colorHFg : this.colorFg);
            if (var5 == null) {
               var5 = (Cell)var4.nextElement();
            }

            if (var5 != null && var4.currRow() == var3 && var4.currCol() == var9) {
               var5.drawCell(this.field_2, this.align[var9], this.splitters[var9] + 3, this.headingHeight + var1 * this.cellHeight + 4, var7, this.cellHeight, this.cellAscent);
               var5 = null;
            }

            if (var5 != null && var4.currRow() < var3) {
               var5 = null;
            }
         }

         --var2;
         if (var2 == 0) {
            break;
         }

         ++var3;
         ++var1;
      }

   }

   boolean postEvent(int var1, int var2) {
      return ((Component)this).postEvent(new Event(this, var1, new Integer(var2)));
   }

   int getPageSize() {
      return ((Component)this).size().height / this.cellHeight;
   }

   void draw3DBox(Rectangle var1, boolean var2) {
      int var3 = var1.x;
      int var4 = var1.y;
      int var5 = var1.x + var1.width;
      int var6 = var1.y + var1.height;
      this.field_2.setColor(var2 ? Color.black : Color.white);
      this.field_2.drawLine(var5, var4, var5, var6);
      this.field_2.drawLine(var5 + 1, var4, var5 + 1, var6);
      this.field_2.drawLine(var3, var6, var5, var6);
      this.field_2.drawLine(var3, var6 + 1, var5, var6 + 1);
      this.field_2.setColor(var2 ? Color.white : Color.gray);
      this.field_2.drawLine(var3, var4, var5 - 2, var4);
      this.field_2.drawLine(var3, var4, var3, var6 - 1);
   }

   void drawHeading(boolean var1) {
      int var3 = 1;
      byte var4 = 1;
      Font var7 = ((Component)this).getFont();
      this.field_2.setFont(this.headingFont);
      FontMetrics var8 = this.field_2.getFontMetrics();
      Dimension var2 = ((Component)this).size();

      for(int var9 = 0; var9 < this.headings.length; ++var9) {
         var3 = this.splitters[var9];
         int var5;
         int var6;
         if (var9 < this.headings.length - 1) {
            var6 = this.splitters[var9 + 1];
            var5 = var6 - var3;
         } else {
            var6 = var2.width;
            var5 = var6 - var3;
         }

         Rectangle var10 = new Rectangle(var3, var4, var5 - 2, this.headingHeight);
         this.draw3DBox(var10, this.colClick != var9);
         this.field_2.setColor(this.headingBg);
         this.field_2.fillRect(var10.x + 1, var10.y + 1, var5 - 3, this.headingHeight - 1);
         this.field_2.setColor(this.headingFg);
         if (this.headings[var9] != null) {
            int var11 = var8.stringWidth(this.headings[var9]);
            int var12 = var5 - 3;
            int var13 = var1 && this.colClick == var9 ? 1 : 0;
            switch (this.align[var9]) {
               case 0:
                  this.field_2.drawString(this.headings[var9], var3 + 8 + var13, this.headingHeight - 3 + var13);
                  break;
               case 1:
                  if (var11 > var12) {
                     this.field_2.drawString(this.headings[var9], var3 + 8 + var13, this.headingHeight - 3 + var13);
                  } else {
                     this.field_2.drawString(this.headings[var9], var3 + (var12 - var11) / 2 + var13, this.headingHeight - 3 + var13);
                  }
                  break;
               case 2:
                  if (var11 > var12) {
                     this.field_2.drawString(this.headings[var9], var3 + 8 + var13, this.headingHeight - 3 + var13);
                  } else {
                     this.field_2.drawString(this.headings[var9], var3 + var12 - var11 - 6 + var13, this.headingHeight - 3 + var13);
                  }
            }

            if (this.colClick == var9) {
               this.field_2.drawLine(var10.x + 1, this.headingHeight + 2, var6 - 3, this.headingHeight + 2);
            }
         }
      }

      this.field_2.setColor(Color.black);
      this.field_2.drawRect(0, 0, var2.width - 1, var2.height - 1);
      this.field_2.setFont(var7);
   }

   Frame frame() {
      Object var1;
      for(var1 = this; var1 != null && !(var1 instanceof Frame); var1 = ((Component)var1).getParent()) {
      }

      return (Frame)var1;
   }

   void changeSelection(int var1, int var2) {
      if (this.multiSelect) {
         switch (var2) {
            case 1:
               for(int var3 = Math.min(this.selectedRow, var1); var3 <= Math.max(this.selectedRow, var1); ++var3) {
                  if (var3 >= 0) {
                     this.highlightedRows.set(var3);
                  }
               }
               break;
            case 2:
               if (this.highlightedRows.get(var1)) {
                  this.highlightedRows.clear(var1);
               } else {
                  this.highlightedRows.set(var1);
               }
               break;
            default:
               this.highlightedRows = new BitSet();
               this.highlightedRows.set(var1);
         }
      } else {
         if (this.selectedRow >= 0) {
            this.highlightedRows.clear(this.selectedRow);
         }

         this.highlightedRows.set(var1);
      }

      int var4 = this.cells.rows();
      if (var1 > var4 - 1) {
         var1 = var4 - 1;
      } else if (var1 < 0) {
         var1 = 0;
      }

      if (var1 < this.topRow) {
         this.topRow = var1 - 1;
         if (this.topRow < 0) {
            this.topRow = 0;
         }

         this.sbPosition = this.topRow;
         this.field_0.setValue(this.sbPosition);
      }

      if (var1 >= -1 + this.topRow + this.getPageSize()) {
         ++this.topRow;
         if (this.topRow > var4 - 1) {
            this.topRow = var1;
         }

         this.sbPosition = this.topRow;
         this.field_0.setValue(this.sbPosition);
      }

      if (this.selectedRow != var1 && var2 > 0) {
         this.postEvent(702, this.selectedRow);
      }

      this.selectedRow = var1;
      this.redraw();
      ((Component)this).repaint();
      this.postEvent(701, var1);
   }

   public synchronized Dimension preferredSize() {
      return new Dimension(175, 125);
   }

   public synchronized Dimension minimumSize() {
      return new Dimension(50, 50);
   }
}
