package symantec.itools.awt;

import java.awt.Image;

public class TreeNode {
   TreeNode sibling;
   TreeNode child;
   TreeNode parent;
   String text;
   Image collapsedImage;
   Image expandedImage;
   int numberOfChildren;
   Object dataObject;
   int depth;
   boolean isExpanded;

   public TreeNode(String var1) {
      this(var1, (Image)null, (Image)null);
   }

   public TreeNode(String var1, Image var2, Image var3) {
      this.depth = -1;
      this.isExpanded = false;
      this.text = var1;
      this.sibling = null;
      this.child = null;
      this.collapsedImage = var2;
      this.expandedImage = var3;
      this.numberOfChildren = 0;
      this.dataObject = null;
   }

   void setDepth(int var1) {
      this.depth = var1;
   }

   public int getDepth() {
      return this.depth;
   }

   public boolean isExpanded() {
      return this.isExpanded;
   }

   public boolean isExpandable() {
      return this.child != null;
   }

   public void expand() {
      if (this.isExpandable()) {
         this.isExpanded = true;
      }

   }

   public void collapse() {
      this.isExpanded = false;
   }

   public void toggle() {
      if (this.isExpanded) {
         this.collapse();
      } else {
         if (this.isExpandable()) {
            this.expand();
         }

      }
   }

   public Image getImage() {
      return this.isExpanded && this.expandedImage != null ? this.expandedImage : this.collapsedImage;
   }

   public void setExpandedImage(Image var1) {
      this.expandedImage = var1;
   }

   public void setCollapsedImage(Image var1) {
      this.collapsedImage = var1;
   }

   public String getText() {
      return this.text;
   }

   public void setText(String var1) {
      this.text = new String(var1);
   }

   public Object getDataObject() {
      return this.dataObject;
   }

   public void setDataObject(Object var1) {
      this.dataObject = var1;
   }
}
