import java.applet.Applet;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Event;
import java.awt.Font;
import java.awt.LayoutManager;
import java.net.MalformedURLException;
import symantec.itools.awt.InvisibleButton;
import symantec.itools.awt.WrappingLabel;
import symantec.itools.lang.Context;
import symantec.itools.multimedia.ImageViewer;
import symantec.itools.net.RelativeURL;

public class SlideShow extends Applet {
   InvisibleButton underInvisibleButtonNext;
   InvisibleButton underInvisibleButtonPrev;
   symantec.itools.multimedia.SlideShow slideShowPhotos;
   WrappingLabel wrappingLabelDesc;
   ImageViewer imageViewerClicker;
   InvisibleButton invisibleButtonPrev;
   InvisibleButton invisibleButtonNext;

   public void init() {
      super.init();
      Context.setDocumentBase(((Applet)this).getDocumentBase());
      ((Container)this).setLayout((LayoutManager)null);
      ((Applet)this).resize(531, 365);
      ((Component)this).setFont(new Font("Dialog", 0, 12));
      ((Component)this).setForeground(new Color(0));
      ((Component)this).setBackground(new Color(16777215));
      this.underInvisibleButtonNext = new InvisibleButton();
      this.underInvisibleButtonNext.reshape(303, 271, 40, 46);
      ((Container)this).add(this.underInvisibleButtonNext);
      this.underInvisibleButtonPrev = new InvisibleButton();
      this.underInvisibleButtonPrev.reshape(257, 276, 44, 46);
      ((Container)this).add(this.underInvisibleButtonPrev);
      this.slideShowPhotos = new symantec.itools.multimedia.SlideShow();

      try {
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_1.gif"), "Pristine Bungbusi beaches are ideal for relaxing and for all kinds of water sports, including surfing, water skiing, and snorkeling.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_8.gif"), "Hiking through the rainforest and touring botanical gardens are some of the many ways to explore the Bungbusi tropical paradise.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_3.gif"), "At the top of Venduca volcano, you can safely watch the volcanic activity.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_7.gif"), "The ocean pounds against rocks formed from past Venduca lava flows.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_2.gif"), "Who were the technologically advanced people that constructed this ancient Simerilian city? This riddle attracts archeologists and curious travelers from around the world.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_4.gif"), "The extinct civilization that lived in Simerilia had indoor plumbing, running water, saunas, enclosed courtyards, and sophisticated art in their city buildings.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_5.gif"), "The beautiful Moderna river slinks through this modern village.");
         this.slideShowPhotos.addImageAndDescription(RelativeURL.getURL("Images/Photo_6.gif"), "Moderna rose gardens bloom year-round.");
         this.slideShowPhotos.display();
      } catch (Exception var2) {
      }

      this.slideShowPhotos.reshape(8, 8, 337, 232);
      this.slideShowPhotos.setFont(new Font("Dialog", 0, 12));
      this.slideShowPhotos.setForeground(new Color(0));
      this.slideShowPhotos.setBackground(new Color(16777215));
      ((Container)this).add(this.slideShowPhotos);
      this.wrappingLabelDesc = new WrappingLabel();
      this.wrappingLabelDesc.setText("Pristine Bungbusi beaches are ideal for relaxing and for all kinds of water sports, including surfing, water skiing, and snorkeling.");
      this.wrappingLabelDesc.reshape(352, 24, 175, 212);
      this.wrappingLabelDesc.setFont(new Font("Dialog", 0, 12));
      this.wrappingLabelDesc.setForeground(new Color(0));
      this.wrappingLabelDesc.setBackground(new Color(16777215));
      ((Container)this).add(this.wrappingLabelDesc);
      this.imageViewerClicker = new ImageViewer();

      try {
         this.imageViewerClicker.setURL(RelativeURL.getURL("Images/Clicker.gif"));
      } catch (MalformedURLException var1) {
      }

      this.imageViewerClicker.reshape(8, 256, 381, 104);
      this.imageViewerClicker.setFont(new Font("Dialog", 0, 12));
      this.imageViewerClicker.setForeground(new Color(0));
      this.imageViewerClicker.setBackground(new Color(16777215));
      ((Container)this).add(this.imageViewerClicker);
      this.invisibleButtonPrev = new InvisibleButton();
      this.invisibleButtonPrev.reshape(259, 276, 41, 43);
      ((Container)this).add(this.invisibleButtonPrev);
      this.invisibleButtonNext = new InvisibleButton();
      this.invisibleButtonNext.reshape(302, 271, 42, 44);
      ((Container)this).add(this.invisibleButtonNext);
   }

   public boolean handleEvent(Event event) {
      if (event.target == this.slideShowPhotos && event.id == 1001) {
         this.slideShowPhotos_SlideChanged(event);
         return true;
      } else if (event.target == this.invisibleButtonNext && event.id == 1001) {
         this.invisibleButtonNext_Action(event);
         return true;
      } else if (event.target == this.invisibleButtonPrev && event.id == 1001) {
         this.invisibleButtonPrev_Action(event);
         return true;
      } else if (event.target == this.underInvisibleButtonNext && event.id == 1001) {
         this.underInvisibleButtonNext_Action(event);
         return true;
      } else if (event.target == this.underInvisibleButtonPrev && event.id == 1001) {
         this.underInvisibleButtonPrev_Action(event);
         return true;
      } else {
         return super.handleEvent(event);
      }
   }

   void invisibleButtonNext_Action(Event event) {
      this.slideShowPhotos.nextImage();
   }

   void invisibleButtonPrev_Action(Event event) {
      this.slideShowPhotos.previousImage();
   }

   void slideShowPhotos_SlideChanged(Event event) {
      this.wrappingLabelDesc.setText(this.slideShowPhotos.getDescription(this.slideShowPhotos.getCurrentImageIndex()));
   }

   void underInvisibleButtonNext_Action(Event event) {
      this.slideShowPhotos.nextImage();
   }

   void underInvisibleButtonPrev_Action(Event event) {
      this.slideShowPhotos.previousImage();
   }
}
