package symantec.itools.awt;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Image;

class ListItem {
   Image image;
   String sText;
   boolean bEnabled;
   boolean bSelected;
   boolean bDirty;
   Color color;
   int lineWidth;
   boolean bCellBorder;
   Color cellBorderColor;
   boolean bEdited = false;

   public ListItem(Image var1, String var2, boolean var3, FontMetrics var4, boolean var5) {
      this.image = var1;
      this.sText = var2;
      this.bEnabled = var3;
      this.bSelected = false;
      this.bDirty = true;
      this.color = null;
      this.bCellBorder = var5;
      this.cellBorderColor = Color.black;
      this.updateWidth(var4);
   }

   public void updateWidth(FontMetrics var1) {
      if (var1 != null) {
         this.lineWidth = var1.stringWidth(this.sText);
      } else {
         this.lineWidth = 0;
      }
   }

   public String toString() {
      String var1 = "ListItem " + this.sText;
      if (this.image != null) {
         var1 = var1 + " [Image]";
      }

      if (this.color != Color.black) {
         var1 = var1 + " [Colored]";
      }

      if (this.bEnabled) {
         var1 = var1 + " [Enabled]";
      } else {
         var1 = var1 + " [Disabled]";
      }

      if (this.bSelected) {
         var1 = var1 + " [Selected]";
      } else {
         var1 = var1 + " [Not Selected]";
      }

      if (this.bDirty) {
         var1 = var1 + " [Dirty]";
      }

      return var1;
   }
}
