package symantec.itools.awt.shape;

import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import symantec.itools.awt.BevelStyle;

public abstract class Shape extends Canvas implements BevelStyle {
   protected int width;
   protected int height;
   protected int style = 2;
   protected boolean fill;
   protected Color fillColor;

   protected Shape() {
   }

   public void setBevelStyle(int var1) {
      this.style = var1;
      ((Component)this).repaint();
   }

   public int getBevelStyle() {
      return this.style;
   }

   public void setFillMode(boolean var1) {
      this.fill = var1;
      ((Component)this).repaint();
   }

   public boolean getFillMode() {
      return this.fill;
   }

   public void setFillColor(Color var1) {
      this.fillColor = var1;
      ((Component)this).repaint();
   }

   public Color getFillColor() {
      return this.fillColor;
   }

   public void reshape(int var1, int var2, int var3, int var4) {
      this.width = var3;
      this.height = var4;
      super.reshape(var1, var2, var3, var4);
   }

   public Dimension preferredSize() {
      return new Dimension(50, 50);
   }
}
