package symantec.itools.multimedia;

import java.awt.Canvas;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.net.MalformedURLException;
import java.net.URL;

public class ImageViewer extends Canvas {
   protected Image image;
   protected String fileName;
   protected URL url;
   protected boolean centerMode;

   public ImageViewer() {
      this.image = null;
      this.fileName = null;
   }

   public ImageViewer(String var1) throws MalformedURLException {
      this.setFileName(var1);
   }

   public ImageViewer(URL var1) {
      this.setURL(var1);
   }

   public ImageViewer(Image var1) {
      this.setImage(var1);
   }

   public void setFileName(String var1) {
      try {
         this.fileName = var1;
         this.setURL(new URL(this.fileName));
      } catch (MalformedURLException var2) {
      }

      ((Component)this).repaint();
   }

   public String getFileName() {
      return this.fileName;
   }

   public void setURL(URL var1) {
      this.url = var1;
      this.fileName = null;
      Image var2 = ((Component)this).getToolkit().getImage(this.url);
      if (var2 != null) {
         this.setImage(var2);
         ((Component)this).repaint();
      }

   }

   public URL getURL() {
      return this.url;
   }

   public void setCenterMode(boolean var1) {
      this.centerMode = var1;
      ((Component)this).invalidate();
   }

   public boolean getCenterMode() {
      return this.centerMode;
   }

   public void setImage(Image var1) {
      this.fileName = null;
      this.image = var1;
      if (var1 != null) {
         try {
            MediaTracker var2 = new MediaTracker(this);
            var2.addImage(this.image, 0);
            var2.waitForID(0);
         } catch (InterruptedException var3) {
         }
      } else {
         ((Component)this).repaint();
      }
   }

   public Image getImage() {
      return this.image;
   }

   public void paint(Graphics var1) {
      if (this.image != null) {
         Dimension var2 = ((Component)this).size();
         var1.clipRect(0, 0, var2.width, var2.height);
         int var3 = 0;
         int var4 = 0;
         if (this.centerMode) {
            var3 += (var2.width - this.image.getWidth(this)) / 2;
            var4 += (var2.height - this.image.getHeight(this)) / 2;
         }

         var1.drawImage(this.image, var3, var4, this);
      }

   }

   public Dimension preferredSize() {
      return this.image != null ? new Dimension(this.image.getWidth(this), this.image.getHeight(this)) : new Dimension(10, 10);
   }

   public Dimension minimumSize() {
      return this.preferredSize();
   }
}
